dnl --=|=-- ANSIC.m4 --=|=--
dnl --=-- This is the m4 include file to expand generic programs --=--
dnl --=-- into C sources for the OTOP subproject --=--
dnl
dnl
dnl - Firstly, have BEGIN/END expanded by CPP, so we won't get mixed up
dnl - with our having m4 quote with {curly braces}
dnl
#define BEGIN	{
#define END	}
dnl
dnl
dnl --- Include the generic m4 macro file, with proper parameters... ---
include(macro.m4)dnl
Provide({ANSIC},{

changecom(/*,*/)dnl
dnl
dnl --- Include the system-dependent configuration... ---
include(config.m4)dnl


dnl --- Define Pseudo-ASM syntax stuff ---

define({Terminator},{;})


dnl --- Define Pseudo-ASM registers ---

defdef({PC},	{PC})dnl	-- program counter
defdef({DSP},	{DSP})dnl	-- data stack pointer
defdef({DSINC},	{(-CELL})dnl	-- increment for data stack, grow down
defdef({TOS},	{TOS})dnl	-- buffered top of stack
defdef({TOSL},	{LowWord(TOS)})dnl	-- its lowest word
defdef({TOSLL},	{LowByte(TOS)})dnl	-- its lowest byte
defdef({TOSLH},	{SecondByte(TOS)})dnl	-- its second byte
defdef({RSP},	{RSP})dnl	-- return stack pointer
defdef({RSINC},	{(-CELL)})dnl	-- increment for return stack -- grow down
defdef({FRAME},	{})dnl	-- a frame pointer for heap manipulation
defdef({R0},	{})dnl	-- a scratch register
defdef({R0L},	{})dnl	-- its lowest word
defdef({R0LL},	{})dnl	-- its lowest byte
defdef({R0LH},	{})dnl	-- its second byte
defdef({R1},	{})dnl	-- second scratch register
defdef({COUNT},	{COUNT})dnl	-- count register
defdef({COUNTLO},{LowByte(COUNT)})dnl	-- count register -- low byte
defdef({INSTRTBL},{InstrT})dnl	-- table for bytecode threading


dnl --- Define Pseudo-ASM type-casting ---

define({bytecast},{((Byte)$1)})
define({wordcast},{((Word)$1)})
define({cellcast},{((Cell)$1)})


dnl --- Define Pseudo-ASM pointers ---

define({point},
   {(*( ((Cell*) ($1)) ifelse({$2},{},,{+ ($2)}) ))})
define({bytepoint},
   {(*( ((Byte*) ($1)) ifelse({$2},{},,{+ ($2)}) ))})
define({wordpoint},
   {(*( ((Word*) ($1)) ifelse({$2},{},,{+ ($2)}) ))})


dnl --- Define Pseudo-ASM Instructions ---

define({Mov},{$1=$2})dnl
define({Add},{$1+=$2})dnl
define({Sub},{$1-=$2})dnl
.......


dnl --- Define Pseudo-ASM structure ---

define({Loop},{for(;COUNT!=0;COUNT--)  BEGIN  $1  END})
define({exit_Loop},{break;})




dnl --- If we are using GCC, use GCC extensions to ANSI C ---
ifdef({GCC},{include({GCC.mh})})


dnl
dnl
})dnl ---- end of ANSIC.m4 ----
dnl
