dnl ---=|=--- default.m4 ---=|=---
dnl ---=--- Default values for macros ---=---
dnl
dnl
Provide({defaults},{
dnl
dnl
dnl --- Pseudo-ASM instructions ---
dnl
defdef({Mov}, {ifelse({$1},,,{$2},,,{$1},{$2},,{__Mov__($1,$2)})})dnl
defdef({Xchg},{ifelse({$1},,,{$2},,,{$1},{$2},,{__Xchg__($1,$2)})})dnl
dnl
defdef({AddIm},{Add($1,$2)})dnl
defdef({Inc},{AddIm($1,1)})dnl
defdef({Dec},{AddIm($1,-1)})dnl
dnl
defdef({Shr},{ifelse($2,,{__Shr__($1,1)},{__Shr__($1,$2)})})dnl
defdef({Shl},{ifelse($2,,{__Shr__($1,1)},{__Shl__($1,$2)})})dnl
dnl
dnl
dnl --- Branching ---
dnl
ifdef({Ifcompare},
   {defdef({Branch},{Ifcompare({$1},{$2},{$3},{Goto($4)})})})dnl
ifdef({Branch},
   {defdef({Ifcompare},
      {pushdef({elsetarget},newlabel)dnl
       pushdef({exittarget},newlabel)dnl
         Branch(negcond({$1}),{$2},{$3},elsetarget)
	 $4
	 ifelse({$5},{},{Goto(exittarget)})
	elsetarget:
	 ifelse({$5},{},{$5})
	exittarget:
       pushdef({elsetarget},newlabel)dnl
       pushdef({exittarget},newlabel)dnl
})})dnl Ifcompare(cond,arg1,arg2,ifclause,opt elseclause)
dnl
dnl
dnl --- Syntax ---
dnl
defdef({__Seq__},{ifelse({$*},,,{shift($@)},,{$1}{Terminator},
	        {$1{}Terminator{}Separator{}__Seq__(shift($@))})})dnl
defdef({Seq},{Begin __Seq__($@) End})dnl
defdef({labelprefix},{Forth_})dnl
dnl
dnl
dnl --- Register Convention ---
dnl
defdef({MDSINC},	{(-DSINC)})dnl	increment for data stack
defdef({DSINC},		{(-MDSINC)})dnl	increment for data stack
defdef({MRSINC},	{(-RSINC)})dnl	increment for data stack
defdef({RSINC},		{(-MRSINC)})dnl	increment for data stack
defdef({DSE},{point(DSP,$1)})dnl
defdef({NOS},{DSE(0)})dnl
defdef({TSE},{DSE(1)})dnl
defdef({FSE},{DSE(2)})dnl
defdef({Nip},{AddIm(DSP,ifelse({$1},{},{MDSINC},{$1*MDSINC}))})dnl
defdef({Pin},{AddIm(DSP,ifelse({$1},{},{DSINC},{$1*DSINC}))})dnl
defdef({PopData}, {__Seq__({Mov($1,TOS)},{Mov(TOS,NOS)},{Nip})})dnl
defdef({PushData},{__Seq__({Pin},{Mov(NOS,TOS)},{Mov(TOS,$1)})})dnl
dnl
dnl
dnl --- Calling Convention ---
dnl
defdef({_Enter_},{AddIm(PC,$1)})dnl
defdef({Enter},{ifelse($#,0,{_Enter_(PCINC)},
		{Mov($1,point(PC,PCINC))
		 _Enter_(2*PCINC)})})dnl
defdef({Next},{Goto(point(PC))})dnl
dnl
dnl
dnl --- Defining a FORTH word ---
dnl
dnl  * to define a FORTH word,
dnl  * ....
dnl  * add an entry in a m4 table, so that we can later
dnl    simulate FORTH compilation from within m4,
dnl    provided the only meta-words used were built into the m4 files...
dnl ......
dnl
dnl
defdef({Label},{OSLK_$1})dnl
defdef({DefSymbol},
{__symbolseg__({
   defcell(StringAddress($1))dnl	the name string
   defcell(SymbolFlags($2))dnl		flags
   defcell(SymbolValue($3))dnl		pointer to the value
})})dnl
dnl
define({__DefWord__},{dnl
pushdef({FWLABEL},Label($2))dnl
DefString({$1})dnl
DefSymbol(DefinedString,{$3},FWLABEL)dnl
FWLABEL:
popdef({FWLABEL})dnl
})dnl
define({__DefAlias__},{dnl
DefString({$1})dnl
DefSymbol(DefinedString,{$3},Label({$4}))dnl
Equate(Label({$2}),Label({$4}))dnl
})dnl
dnl
dnl
defdef({DefWord},
   {__DefWord__({$1},ifelse({$2},,{{$1}},{{$2}}),shift(shift($@)))})dnl
defdef({DefAlias},
   {__DefAlias__({$1},ifelse({$2},,{{$1}},{{$2}}),shift(shift($@)))})dnl
dnl
dnl
dnl --- Constant values ---
dnl
defdef({TRUE},{-1})	dnl -- Logical True value
defdef({FALSE},{0})	dnl -- Logical False value
dnl
dnl
dnl --- Deduced values ---
dnl
defdef({CHARSIZE},eval(1 << CHARABITS))dnl --	size of a char in bytes
defdef({WORDSIZE},eval(1 << WORDABITS))dnl --	size of a char in bytes
defdef({CELLSIZE},eval(1 << CELLABITS))dnl --	size of a cell in bytes
defdef({PAGESIZE},eval(1 << PAGEABITS))dnl --	size of a page in bytes
defdef({CHARMASK},eval(~ (CHARSIZE - 1)))dnl --	mask of chars in address
defdef({WORDMASK},eval(~ (WORDSIZE - 1)))dnl -- mask of words in address
defdef({CELLMASK},eval(~ (CELLSIZE - 1)))dnl -- mask of cells in address
defdef({PAGEMASK},eval(~ (PAGESIZE - 1)))dnl -- mask of pages in address
defdef({BITSPERCHAR},eval(CHARSIZE*BYTEBITS))dnl --	bits in a char
defdef({BITSPERCELL},eval(CELLSIZE*BYTEBITS))dnl --	bits in a cell
dnl
dnl
})dnl ----- end of defaults.m4 -----
dnl
