comment({	Portable implementation of the LLL kernel	})dnl
dnl
comment({	The choice constructs will select the best	})dnl
comment({	implementation ;-)				})dnl
dnl
Provide({kernel},{
Require({choice})
Require({defaults})
dnl
dnl
dnl ---------------------------- Comments -----------------------------------
dnl
dnl * Whenever a common interface can be found, move everything
dnl  from choices to macros defined in specialization files.
dnl
dnl * ANS Forth recommends TOS=hi, NOS=lo for double word set
dnl  we follow this recommendation.
dnl
dnl * Here are only asm-implemented words
dnl
dnl * Choice should be made in another way:
dnl   1) define a list of rules/choices
dnl   2) define a list of requirements
dnl  That's logic programming !
dnl  Only the inference machine chooses between versions according
dnl  to some notion of fitness.
dnl  ...
dnl
dnl
dnl ------------------------- Defining Macros -------------------------------
dnl
dnl
dnl
define({DefBinOpWord},
{DefWord({$1},{$2},{$3})
   Enter
   $4(TOS,NOS)
   Nip
   Next
})dnl
dnl
define({DefUnOpWord},
{DefWord({$1},{$2},{$3})
   Enter
   $4(TOS,$5)
   Nip
   Next
})dnl
dnl
dnl
dnl
dnl
__codeseg__({



dnl -------- Integer Arithmetics ---------


DefBinOpWord(SWAP-,RSUB,,{Sub})
DefUnOpWord(2/,SHR,,{Shr},1)

DefWord(-,SUB)
	Neg(TOS)
DefBinOpWord(+,ADD,,{Add})


DefWord(>>,SHRN)
	Enter
	PopData(COUNT)
	Shr(TOS,COUNTLO)
	Next

DefWord(NEGATE)
	Enter
  Neg0:	Neg(TOS)
	Next


DefWord(ABS)
	Enter
choice({
    option({generic},{
	Branch(l,TOS,0,Neg0)
    })
    forget({i386},{
	Mov(eax,TOS)
	CDQ
	Xor(eax,edx)
	Sub(eax,edx)
	Mov(TOS,eax)
    })
})
	Next


DefUnOpWord(1+,INC,,{Inc})




dnl ---------- Basic Multiplication operators ---------


DefWord(M*,m_star)
	Enter
choice({
    option({i386},{
	Mov(eax,NOS)
	imul TOS
	Mov(NOS,eax)
	Mov(TOS,edx)
    })
    option({ANSIC},{
	......
    })
    option({GCC},{
        sdCell Prod = TOS * NOS ;
	Mov(NOS,(Cell)Prod) ;
	Mov(TOS,(Cell)(Prod>>CELLABITS)) ;
    })
})
	Next


DefWord(UM*,u_m_star)
	Enter
choice({
    option({i386},{
	Mov(eax,NOS)
	mul TOS
	Mov(NOS,eax)
	Mov(TOS,edx)
    })
    option({ANSIC},{
	......
    })
    option({GCC},{
        udCell Prod = (uCell)TOS * (uCell)NOS ;
	Mov(NOS,(uCell)Prod) ;
	Mov(TOS,(uCell)(Prod>>CELLABITS)) ;
    })
})
	Next


DefWord(SM/REM,s_m_slash_rem)
	Enter
choice({
    option({i386},{
	Mov(edx,NOS)
	Nip
	Mov(eax,NOS)
	idiv TOS
	Mov(NOS,edx)	; remainder
	Mov(TOS,eax)	; quotient
    })
    option({ANSIC},{
	......
    })
    option({GCC},{
        sdCell D = (sdCell)(  (uCell)TOS | (uCell)(NOS<<CELLABITS)  );
	Mov(NOS,(Cell)(D % TOS)) ;
	Mov(TOS,(Cell)(D / TOS)) ;
    })
})
	Next


DefWord(UM/MOD,u_m_slash_mod)
	Enter
choice({
    option({i386},{
	Mov(edx,NOS)
	Nip
	Mov(eax,NOS)
	div TOS
	Mov(NOS,edx)	; remainder
	Mov(TOS,eax)	; quotient
    })
    option({ANSIC},{
	......
    })
    option({GCC},{
        udCell D = (udCell)(  (uCell)TOS | (uCell)(NOS<<CELLABITS)  );
	Mov(NOS,(uCell)(D % (uCell)TOS)) ;
	Mov(TOS,(uCell)(D / (uCell)TOS)) ;
    })
})
	Next


DefWord(FM/REM,s_m_slash_rem)
	Enter
choice({
    option({i386},{
	Mov(edx,NOS)
	Nip
	Mov(eax,NOS)
	idiv TOS
	Mov(NOS,edx)	; remainder
	Mov(TOS,eax)	; quotient
    })
    option({ANSIC},{
	......
    })
    option({GCC},{
        fdiv_t res = smdiv (num, denom);
        if (res.rem && (num.hi ^ denom) < 0)
        res.quot--, res.rem += denom;

        sdCell D = (sdCell)(  (uCell)TOS | (uCell)(NOS<<CELLABITS)  );
	Mov(NOS,(Cell)(D % TOS)) ;
	Mov(TOS,(Cell)(D / TOS)) ;
    })
})
	Next



dnl ------------ Pointer Arithmetics -------------

DefUnOpWord(CELL+,CELL_PLUS,,{Add},CELL)
DefUnOpWord(CELLS,,,{Shl},CELLABITS)




dnl ---------- Integer as boolean arrays Arithmetics ----------

DefUnOpWord(NOT,,,{Not})
DefAlias(INVERT,,,NOT)

DefBinOpWord(AND,,,{And})
DefBinOpWord(XOR,,,{Xor})
DefBinOpWord(OR,,,{Or})

DefAlias(FLAG,,,0NEQ)



dnl ---------------- USING POINTERS -----------------

DefWord(!,STO)
	Enter
	Mov(R0,NOS)
	Mov(point(TOS),R0)
	Mov(TOS,TSE)
	Nip(2)
	Next

DefWord(@,LOD)
	Enter
	Mov(TOS,point(TOS))
	Next


DefWord(C!,CSTO)
	Enter
	Mov(R0,NOS)
	Mov(pointb(TOS)),R0LL)
	Mov(TOS,TSE)
	Nip(2)
	Next

DefWord(C@,CLOD)
	Enter
choice({
    option({i386},{
	movzx TOS,pointb(TOS)
    })
    option({generic},{
	Mov(TOSLL,pointb(TOS))
	And(TOS,~CHARMASK)
    })
})
	Next

DefWord(W!,WSTO)
	Enter
	Mov(R0,NOS)
	Mov(pointw(TOS),R0L)
	Mov(TOS,TSE)
	Nip(2)
	Next

DefWord(W@,WLOD)
	Enter
choice({
    option({i386},{
	movzx TOS,pointw(TOS)
    })
    option({generic},{
	Mov(TOSL,pointw(TOS))
	And(TOS,~WORDMASK)
    })
})
	Next




dnl ------------------------ NUMBER COMPARISON ------------------------------

dnl --- Equality ---

DefCompareWord0(0=,0EQ,,==,z)
DefCompareWord0(0<>,0NEQ,,!=,nz)

DefCompareWord(=,EQ,,==,z)
DefCompareWord(<>,NEQ,,!=,nz)


dnl --- Signed number comparison to zero ---

DefCompareWord0(0<,0LT,,<,s)
DefCompareWord0(0>=,0GE,,>=,ns)
DefCompareWord0(0>,0GT,,>,g)
DefCompareWord0(0<=,0LE,,<=,le)

DefCompareWord(<,LT,,<,l)
DefCompareWord(>=,GE,,>=,ge)
DefCompareWord(>,GT,,>,g)
DefCompareWord(<=,LE,,<=,le)


dnl --- Unsigned number comparison to zero ---

DefCompareWord(U<,ULT,,<,b)
DefCompareWord(U>=,UGE,,>=,ae)
DefCompareWord(U>,UGT,,>,a)
DefCompareWord(U<=,ULE,,<=,be)




dnl --------------------------- CONSTANTS ------------------------------

define({DefConstWord},{
DefWord($1,$2)
	Enter
	PushData(ifelse($3,,$1,$3))
	Next
})

DefConstWord(-1,MINUS1)
DefConstWord(-2,MINUS2)
DefConstWord(-4,MINUS4)
DefConstWord({MAXINT},{MAXINT},MAX_INT)
DefConstWord({MININT},{MININT},MIN_INT)
DefConstWord(0,ZERO)
rept(31,{DefConstWord(i,PLUS{}i,i)})


dnl ----------------------- STACK MANIPULATION -------------------------

DefWord(SWAP)
	Enter
	Xchg(TOS,NOS)
	Next

DefWord(NOP)
	Enter
	Next

DefWord(OVER)
	Enter
	PushData
	Mov(TOS,TSE)
	Next

DefWord(DUP)
	Enter
	PushData(TOS)
	Next

DefWord(PICK)
	Enter
	dnl (!) Here we assume DSINC is negative (stack grow down) !!!!
	Mov(TOS,DSE(TOS)) 
	Next

DefWord(ROT)
	Enter
	Mov(R0,NOS)
	Mov(NOS,TOS)
	Mov(TOS,TSE)
	Mov(TSE,R0)
	Next

DefWord(ROTROT)
	Enter
	Mov(R0,TSE)
	Mov(TSE,TOS)
	Mov(TOS,NOS)
	Mov(NOS,R0)
	Next


dnl (!) DROP must follow !!!
DefWord(DROP)
	Mov(TOS,NOS)

dnl (!) NIP must follow !!!
DefWord(NIP)
	Enter
	Nip
	Next



DefWord(ROLL)
dnl (!) Here we assume stacks grow down !!!
choice({
  option({ANSIC},{
	for (R0 = DSE(TOS) ;
	     TOS > 0;
	     TOS--)
	    DSE(TOS) = DSE(TOS-1) ;
	TOS = R0 ;
	})
  option({generic},{
	Mov(COUNT,TOS)
	Mov(R0,DSP)
	Mov(TOS,point(R0))
	Loop({
	   AddIm(R0,MDSINC)
	   Xchg(TOS,point(R0))
	})
	})
})
	Enter
	Nip
	Next


DefWord(ROLLD)
dnl (!) Here we assume stacks grow down !!!
dnl (!) Here we assume stacks grow down !!!
choice({
  option({ANSIC},{
	for (R0 = DSE(0), COUNT = 0 ;
	     COUNT < TOS
	     COUNT++)
	    DSE(COUNT) = DSE(COUNT+1) ;
	DSE(TOS) = R0 ;
	})
  option({generic},{
	Mov(COUNT,TOS)
	Mov(TOS,DSE(0))
	Loop({
	   Xchg(TOS,DSE(COUNT))
	})
	})
})
	PopData
	Next


DefWord(2NIP)
	Enter
	Mov(TOS,TSE)
	Mov(R0,NOS)
	Nip(2)
	Mov(NOS,R0)
	Next


DefWord(2SWAP)
	Enter
	Xchg(TOS,TSE)
	Mov(R0,NOS)
	Xchg(R0,FSE)
	Mov(NOS,R0)
	Next


DefWord(2DUP)
	Enter
	Mov(R0,NOS)
	Pin(2)
	Mov(NOS,R0)
	Mov(TSE,TOS)
	Next


DefWord(2OVER)
	Enter
	Mov(R0,FSE)
	Pin(2)
	Mov(NOS,R0)
	Mov(TSE,TOS)
	Mov(TOS,DSE(3))
	Next


dnl
dnl --------------- Words that deal with the program encoding ---------------
dnl

dnl (!) These assume that threading is done by cell.
dnl (!) adapting op size to something else than cell is possible !!!

DefWord(PUSHIMM)
	Enter(PC)
	Next

DefWord(GOTO)
	dnl Enter
	PopData(PC)
	Next

DefWord(GOTONZ)
	Ifcompare(nz,NOS,0,{
		Mov(PC,TOS)	dnl (!) beware we didn't "Enter"
	})
dnl (!) !!! 2DROP must follow

DefWord(2DROP)
	Enter
	dnl (!)
	Mov(TOS,TSE)
	Nip(2)
	Next

DefWord(JSR)
	PushReturn(PC)
	Enter(PC)
	Next

DefWord(RET)
	PopReturn(PC)
	Next

dnl DefWord()


dnl ----------------------- Multithreading -----------------------------

DefWord(PAUSE)
	Enter
	Call(Pause)
	Next

})dnl
dnl
dnl
})dnl --------------------- end of kernel.m4 ------------------------------
dnl
