dnl ------------------------- as86 Macro Library -----------------------------
dnl (c) Franois-Ren "Far" Rideau Dang-Vu Bn 1989,1995
dnl see info file .../doc/info/m4macros.nfo (section * as86.m4::)
dnl
Provide({as86},{
dnl
dnl
dnl --- as86 Assembler syntax ---
dnl
changecom({;})dnl
define({comment},{;$*})dnl
define({Hexnumber},{0x$1})dnl
dnl
dnl
dnl --- Architecture-dependent information ---
dnl
define({__BYTE_ORDER},1234)dnl
dnl define({PAGESIZE},4096)dnl
dnl define({PAGEBITS},12)dnl
dnl
dnl
dnl --- Assembly control information ---
dnl
define({i386usemode},{})dnl
define({i386usemoderegext},{})dnl
define({use16},
    {{use16}
     define({i386usemode},{})
     define({i386usemoderegext},{})})dnl
define({use32},
    {{use32}
     define({i386usemode},{d})
     define({i386usemoderegext},{e})})dnl
define({regext},
    {cat(i386usemoderegext,$@)})dnl
define({isreg},
	{ifelse(regexp(downcase($1),
			{^e?\([a-d][hlx]\|[sd]i\|[sb]p\)$},1),
		1,1,0)})dnl
dnl
dnl
dnl --- Instruction set enhancement macros ---
dnl
dnl
dnl
define({clr},{ifelse(isreg($1),1,{xor $1,$1},{mov $1,#0})})dnl
define({setf},{ifelse(isreg($1),1,{or $1,$1},{test $1,#-1})})dnl
define({bswaperx},
  {xchg $1l,$1h
   rol e$1x,16
   xchg $1l,$1h})dnl
define({flushinstr},{local(fi,{jmp fi
fi:})})dnl
dnl
define({pushax},{cat({pusha},i386usemode)})dnl
define({popax},{cat({popa},i386usemode)})dnl
dnl beware !!!
dnl instruction following a popa should NOT use base+index register
dnl addressing, or else most 386 cpus will trash eax, or even crash !
dnl
define({pushfx},{cat({pushf},i386usemode)})dnl
define({popfx},{cat({popf},i386usemode)})dnl
dnl
define({pushm},
   {irp({param},{$@},
	 {ifelse(regexp(param,{[af][dx]?$}),0,{{push}param{}__nl__},
		 {{push} param{}__nl__})})})dnl
define({popm},{_popm(reverse($@))})dnl
define({_popm},
   {irp({param},{$@},
	 {ifelse(regexp(param,{[af][dx]?$}),0,{{pop}param{}__nl__},
		 {{pop} param{}__nl__})})})dnl
dnl
dnl
define({__unseg__},
   {ifelse(regexp({$2},{\(.*\):\(.*\)},
		  {pushdef({_seg_},{\1})pushdef({_ofs_},{\2})1}),
	   1,
	   {seg _seg_
	    $1 _ofs_ $3 popdef({_seg_})popdef({_ofs_})},
	   {$1 $2 $3})})dnl
dnl
dnl
dnl
dnl --- Memory allocation ---
dnl
define({newheap},
	{ifelse($#,1,{define({heap_$1},0)}{define({heapprefix_$1},{})},
		$#,2,{define({heap_$1},{$2})}{define({heapprefix_$1},{})},
		{define({heap_$1},{$3})}{define({heapprefix_$1},{$2+})})})dnl
define({allot},{cat(heapprefix_$1,varadd({heap_$1},$2))})dnl
define({_alignoffset},
	{ifelse($#,0,0,
		$#,1,0,
		$#,2,{eval(($2-1)-(($1+$2-1)%($2)))},
		{eval(($2-1)-(($1-$3+$2-1)%($2)))})})dnl
define({_aligned},{eval(_alignoffset($@)+$1)})dnl
define({alignheap},{ifelse(allot({$1},_alignoffset(heap_$@)))})dnl
define({alallot},
	{ifelse($#,0,,$#,1,,
		$#,2,{alignheap({$1},{$2}){}allot({$1},{$2})},
		{alignheap({$1},{$2}){}allot({$1},{$3})})})dnl
define({_member},{dnl
  ifelse({
	{{$1}} is member type size
	{{$2}} is field name
	{{$3}} is multiplier
	{{$4}} is alignment required
  })dnl
  ifelse({$4},,,
	 {alignheap(StrucName,{$4})})
  ifelse({$2},,,{StrucName{$2} = })dnl
  ifelse({$3},,
	 {allot(StrucName,{$1})},
	 {allot(StrucName,eval({$1}*{$3}))})
})dnl
define({_byte},
	{ifelse($#,0,,$#,1,,
		$#,2,{alignheap({$1},{$2}){}allot({$1},{$2})},
		{alignheap({$1},{$2}){}allot({$1},{$3})})})dnl
dnl
dnl
dnl --- Structures ---
dnl
define({StrucName},{})dnl
define({Struc},
{pushdef({StrucName},StrucName{$1_})dnl
cat(newheap(StrucName),shift($@))dnl
sizeof_$1 = allot(StrucName,0)
popdef({StrucName})dnl
})dnl
define({_member_},
  {forget({
	{{$1}} is member type size
	{{$2}} is field name
	{{$3}} is multiplier
	{{$4}} is alignment required
  })dnl
  ifelse({$4},,,
	 {alignheap(StrucName,{$4})})dnl
  ifelse({$2},,,{StrucName{$2} = })dnl
  ifelse({$3},,
	 {allot(StrucName,{$1})},
	 {allot(StrucName,eval({$1}*{$3}))})
})dnl
define({_byte__},{_member_(1,$@)})dnl
define({_word__},{_member_(2,$@)})dnl
define({_long__},{_member_(4,$@)})dnl
define({_byte_},{_member_(1,{$1},{$2})})dnl
define({_word_},{_member_(2,{$1},{$2},2)})dnl
define({_long_},{_member_(4,{$1},{$2},4)})dnl
dnl
dnl
dnl --- Useful constants ---
dnl
; ASCII codes
LF	=	0x0A
CR	=	0x0D
define({CRLF},{CR,LF})dnl
Escape	=	0x1B
; Keyboard scancodes
K_Home	=	0x47
K_Up	=	0x48
K_PgUp	=	0x49
K_Lft	=	0x4B
K_Rgt	=	0x4D
K_EndC	=	0x4F
K_Dn	=	0x50
K_PgDn	=	0x51
K_InsC	=	0x52
K_Del	=	0x53
dnl
dnl
dnl ---------------------- Structured programming ---------------------------
dnl
__newstk__({struct})dnl
dnl --- negating code condition
define({ncc},
	{ifelse({$1},{po},{pe},
		{$1},{pe},{po},
		regexp({$1},{^n\(.*\)},{T}),{T},regexp({$1},{^n\(.*\)},{\1}),
		{n}{$1})})dnl
define({jn},
	{{j}ncc($1) shift($@)})dnl
dnl
dnl
dnl --- __IF__ ... __THEN__ ... ( __ELSE__ ...) __ENDIF__ ---
dnl
define({IFNUM},0)dnl
define({__EXIT__IF__},{ENDIF})dnl
define({__EXIT__ELSE__},{ENDIF})dnl
define({__EXIT__THEN__},{ENDIF})dnl
define({__IF__},
	{__push__({struct},{@IF:varincr({IFNUM}):{$1}})})dnl
define({__THEN__},
  {ifelse(
    regexp(__pick__({struct}),{@IF:\(.*\):\(.*\)},
		{1{}pushdef({ifnum},{\1})pushdef({cc},{\2})}),
    1,
    {__pop__({struct})
     jn(cc) {ELSE}ifnum
     __push__({struct},{@THEN:}ifnum:)popdef({ifnum})popdef({cc})},
     {errprint({__THEN__ does not match __IF__},
		__pick__({struct}),__nl__)})})dnl
define({__ELSE__},
  {ifelse(
    regexp(__pick__({struct}),{@THEN:\(\w\):},{1{}pushdef({ifnum},{\1})}),
    1,
    {__pop__({struct})
     jmp {ENDIF}ifnum
     {ELSE}ifnum:
     __push__({struct},{@ELSE:}ifnum:)popdef({ifnum})},
    {errprint({__ELSE__ DOES NOT MATCH __THEN__},
		__pick__({struct}),__nl__)})})dnl
dnl
define({__ENDIF__},
  {ifelse(
     regexp(__pick__({struct}),
            {@THEN:\(.*\):},
	    {1{}pushdef({ifnum},{\1})}),
     1,
     {__pop__({struct})
      {ELSE}ifnum:
      {ENDIF}ifnum:
      popdef({ifnum})},
     regexp(__pick__({struct}),
            {@ELSE:\(\w\):},
            {1{}pushdef({ifnum},{\1})}),
     1,
     {__pop__({struct})dnl
      {ENDIF}ifnum:
      popdef({ifnum})},
     {errprint({__ENDIF__ does not match __THEN__ or __ELSE__},
		__pick__({struct}),__nl__)}
)})dnl
dnl
dnl
dnl --- __REPEAT__ ... __UNTIL__ ---
dnl
define({REPEATNUM},0)dnl
define({__EXIT__REPEAT__},{UNTIL})dnl
define({__REPEAT__},
	{__push__({struct},{@REPEAT:}REPEATNUM:)
		{REPEAT}REPEATNUM:
		incrvar({REPEATNUM})
	})dnl
define({__UNTIL__},
  {ifelse(
     regexp(__pick__({struct}),
            {@REPEAT:\(.*\):},
	    {1{}pushdef({repeatnum},{\1})}),
     1,
     {__pop__({struct})
	jn({$1}) {REPEAT}repeatnum
	{UNTIL}repeatnum:
      popdef({repeatnum})},
     {errprint({__UNTIL__ does not match __REPEAT__},
		__pick__({struct}),__nl__)}
)})dnl
dnl
dnl --- __WHILE__ ... __DO__ ... __WEND__ ---
dnl
define({WHILENUM},0)dnl
define({__EXIT__WHILE__},{WEND})dnl
define({__EXIT__DO__},{WEND})dnl
define({__WHILE__},
	{__push__({struct},{@WHILE}:WHILENUM:{$1})
		{WHILE}WHILENUM:
		incrvar({WHILENUM})
	})dnl
define({__DO__},
  {ifelse(
    regexp(__pick__({struct}),{@WHILE:\(.*\):\(.*\)},
		{1{}pushdef({whilenum},{\1})pushdef({cc},{\2})}),
    1,
    {__pop__({struct})
     jn(cc) {WEND}whilenum
     __push__({struct},{@DO}:whilenum:)popdef({whilenum})popdef({cc})},
     {errprint({__DO__ does not match __WHILE__},
		__pick__({struct}),__nl__)})})dnl
define({__WEND__},
  {ifelse(
     regexp(__pick__({struct}),
	    {@DO:\(.*\):},
	    {1{}pushdef({whilenum},{\1})}),
     1,
     {__pop__({struct})
      jmp {WHILE}whilenum
      {WEND}whilenum:
      popdef({whilenum})},
     {errprint({__WEND__ does not match __DO__},
		__pick__({struct}),__nl__)}
)})dnl
dnl
dnl
dnl --- __EXIT__ ---
dnl
define({__EXIT__},
  {ifelse(
     regexp(__pick__({struct},eval($1-1)),
	    {@\(.*\):\(.*\):.*},
	    {1{}pushdef({struc},{\1})pushdef({num},{\2})}),
     1,
     {j$2 indir({__EXIT__}struc{__}){}num
      popdef({struc})popdef({num})},
     {errprint({cannot __EXIT__ what ???},__pick__({struct}),__nl__)})})dnl
dnl
dnl
dnl ---------------------------- Diversions ----------------------------------
dnl
define({stringdiversion},5)dnl
dnl
define({__textseg__},
    {indiversion(0,{
	.text
$*})})dnl
define({__codeseg__},
    {indiversion(0,{
	.text
$*})})dnl
define({__stringseg__},
    {indiversion(stringdiversion,{
	.text
$*})})dnl
define({__dataseg__},
    {indiversion(0,{
	.data
$*})})dnl
define({__udataseg__},
    {indiversion(0,{
	.bss
$*})})dnl
define({__end__},
    {undivert})dnl
dnl
dnl
dnl --------------------- Data definition ---------------------
dnl
define({quotestring},{"patsubst({$1},{\"},{\\""})"})dnl
define({defb},
  {ifelse(
    {$#},0,,
    {$#},1,{defbone({$1})},
    {defbone({$1})defb(shift($@))})})dnl
define({defbone},
  {ifelse(
     regexp({$1},{^\( 	\)*".*"},{1}),{1},
     {	.ascii $1}__nl__,
     {	.byte $1}__nl__)})dnl
dnl
define({defstring},
{dnl
pushdef({labelprefix},{S})dnl
pushdef({string},newlabel)dnl
__stringseg__({
string:
defb($@)
})dnl
string{}dnl
popdef({labelprefix})dnl
popdef({string})})dnl
define({stringaddr},{$1})
dnl
define({lsa},{mov {$1},#stringaddr{}defstring(shift($@))})dnl
dnl
ifelse({
dnl ---------------- Exportation de donnees -----------------------
Macro	Export	Identifier , Type , Name
  Local StringAddress, EName
  % ifnb <Name>
      EName equ Name
  % else
      EName equ Identifier
  % endif
  Segment HeaderStrings
    StringAddress:
    %	db	"Name" , 0
  EndS
  Segment HeaderBinary
	dd	StringAddress, ID, Type
  EndS
EndM
})
dnl
dnl
dnl ------------------------------- CONSOLE I/O ------------------------------
dnl
define({PUTC},
    {ifelse($#,0,,{mov al,{$1}})
     call Putc})dnl
define({CGETC},
    {
     ifelse({$1},,,
	{ifelse({$2},,,{pushax})
	 PUTS($1)
	 ifelse({$2},,,{popax})})
	call cGetc})dnl
define({PUTS},
    {
     ifelse({$*},{{CRLF}},{call PrCRLF},
	    {$*},{CRLF},{call PrCRLF},
	    {$*},{CR,LF},{call PrCRLF},
	    {$*},{13,10},{call PrCRLF},
	{ifelse({$1},,,{lsa(regext(si),$@,0)})
	 call Puts})})dnl
dnl
dnl _Pr????_: msg1, [Addr: seg,] val, msg2
define({_PrByte_},
    {pushax
     ifelse({$2},{al},,{__unseg__({mov al,},{$2})})
     ifelse({$1},,,
	{push regext(ax)
	 PUTS($1)
	 pop regext(ax)})
     call PutHexByte
     ifelse({$3},,,{PUTS($3)})
     popax})dnl
define({_PrWord_},
    {pushax
     ifelse({$2},{ax},,{__unseg__({mov ax,},{$2})})
     ifelse({$1},,,
	{push regext(ax)
	 PUTS($1)
	 pop regext(ax)})
     call PutHexWord
     ifelse({$3},,,{PUTS($3)})
     popax})dnl
define({_PrAddr_},
    {pushax
     __unseg__({push},{$3}) ; ofs
     __unseg__({push},{$2}) ; seg
     ifelse({$1},,,{PUTS($1)})
     pop es
     pop regext(di)
     call PutAddr
     ifelse({$4},,,{PUTS($4)})
     popax})dnl
define({_PrDword_},
    {pushad
     ifelse({$1},,
        {ifelse({$2},{eax},,{__unseg__({mov eax,},{$2})})},
	{__unseg__({push dword},{$2})
	 PUTS($1)
	 pop eax})
     call PutHexDword
     ifelse({$3},,,{PUTS($3)})
     popad
     nop})dnl
dnl
dnl _Pr*Zone_: mes1,seg,addr,len,mes2
define({_PrZone_},
    {pushax
     ifelse({$1},,
	{ifelse({$2},{es},,
		{__unseg__({push},{$2})
		 pop es})
	 ifelse({$3},{regext(di)},,
		{__unseg__({mov regext(di),},{$3})})
	 ifelse({$4},{regext(cx)},,
		{__unseg__({mov regext(cx),},{$4})})},
	{pushm({$3},{$4})
         ifelse({$2},{es},,{push $2})
	 PUTS($1)
         ifelse({$2},{es},,{pop es})
	 popm(regext(di),regext(cx))})
     call PutZone
     ifelse({$2},{es},,{pop es})
     ifelse({$5},,,{PUTS($5)})
     popax})dnl
define({_PrWZone_},
    {pushax
     ifelse({$2},{es},,{push es})
     ifelse({$1},,
	{ifelse({$2},{es},,
		{__unseg__({push},{$2})
		 pop es})
	ifelse({$3},{regext(di)},,
		{__unseg__({mov regext(di),},{$3})})
	ifelse({$4},{regext(cx)},,
		{__unseg__({mov regext(cx),},{$4})})},
	{pushm({$2},{$3},{$4})
	 PUTS($1)
	 popm(es,regext(di),regext(cx))})
     call PutWZone
     ifelse({$2},{es},,{pop es})
     ifelse({$5},,,{PUTS($5)})
     popax})dnl
define({_PrLZone_},
    {pushad
     ifelse({$2},{es},,{push es})
     ifelse({$1},,
	{ifelse({$2},{es},,
		{__unseg__({push},{$2})
		 pop es})
	ifelse({$3},{regext(di)},,
		{__unseg__({mov regext(di),},{$3})})
	ifelse({$4},{regext(cx)},,
		{__unseg__({mov regext(cx),},{$4})})},
	{pushm({$2},{$3},{$4})
	 PUTS($1)
	 popm(es,regext(di),regext(cx))})
     call PutLZone
     ifelse({$2},{es},,{pop es})
     ifelse({$5},,,{PUTS($5)})
     popad
     nop})dnl
dnl
dnl
dnl --------------------------- DEBUGGING AID -------------------------------
dnl
undefine({DEBUG})dnl
define({__OUT__},
    {zzz({_OUT_($@)})})dnl
define({zzz},{ifdef({DEBUG},{$1},{$2})})dnl
define({zzzz},{ifdef({__DEBUG__},{$1},{$2})})dnl
define({__},
    {zzz({
     pushax
     PUTS($@)
     popax
     })})
define({z_z},
    {zzz({
     ifelse({$1},,,
	{pushax
	 PUTS($1)
	 popax})
     call DumpRegs
     ifelse({$2},,,
	{pushax
	 CGETC
	 popax})
     })})dnl
define({z__z},
    {zzz({
     ifelse({$1},,,
	{pushax
	 PUTS($1)
	 popax})
     call DumpERegs
     ifelse({$2},,,
	{pushax
	 CGETC
	 popax})
     })})dnl
define({zbyz},
    {zzz({
     _PrByte_($@)
     })})dnl
define({zwoz},
    {zzz({
     _PrWord_($@)
     })})dnl
define({zdwoz},
    {zzz({
     _PrDword_($@)
     })})dnl
define({zaddrz},
    {zzz({
     _PrAddr_($@)
     })})dnl
define({zZonez},
    {zzz({
     _PrZone_($@)
     })})dnl
define({zWZonez},
    {zzz({
     _PrWZone_($@)
     })})dnl
define({zLZonez},
    {zzz({
     _PrLZone_($@)
     })})dnl
dnl ---- Heavy debugging ----
define({STEP},
    {ifdef({__DEBUG__},
	{push {$1}
	 pop gs})})dnl
dnl
dnl STOP(seg,vidmembase,x,y,char,attr)
define({STOP},
    {zzzz({ifelse({$1},{ds},,{seg {$1}})
	 mov word [{$2}+2*{$3}+2*80*{$4}],#(({$5})+(256*{$6}))})})dnl
define({SST},
    {ifdef({__DEBUG__},
	{pushax
	 CGETC({$@})
	 popax})})dnl
dnl
dnl
dnl -------------------- Writing Libraries as Include files ------------------
dnl
dnl This is object managing at source code level. Reduces the number of
dnl object files (one source for any model), allows inlining, etc.
dnl
dnl To Do: use the STRUCSTK for this
dnl use markers to see if a particular procedure was already defined
dnl
define({LibProc},{
  pushdef({__RET__},{ret})
$1:
  indir(Lib_{$1},shift($@))
  popdef({__RET__})
})dnl
define({LibFarProc},{
  pushdef({__RET__},{retf})
$1:
  indir(Lib_{$1},shift($@))
  popdef({__RET__})
})dnl
define({LibInline},{
  pushdef({__RET__},{})
  indir(Lib_{$1},shift($@))
  popdef({__RET__})
})dnl
define({LibMacro},{
dnl  pushdef({__RET__},{})
dnl  indir(Lib_{$1},shift($@))
dnl  popdef({__RET__})
})dnl
dnl
dnl
dnl ------------------------ Procedure library ------------------------------
dnl
dnl --- detecting CPU type ---
define({Lib_TestCPU},{
  ;;;; Procedure taken from Robert L. Hummel's book on 80x86 programming
  ;
  ; AH
  ; 01	8088 or 8086
  ; 02	80286
  ; 03	80386
  ; 04	486
  ;
  ; AL
  ; 00	No FPU
  ; 01	8087
  ; 02	80287
  ; 03	80387
  ; 04	486DX or 487SX
  ;
  ; Note: 0400 <=> 486SX w/o FPU.
  ;;;;;;
  ; destroys all general purpose registers, including FP registers
	MOV	DX,0x100	; default answer
	mov	ax,-1		; non zero
	push	ax		; was [NDP_STATUS],-1 ;
	MOV	BP,SP		; save SP
  ;; on 8088/8086, bits 12 to 15 of pushed Flags value are set,
  ;; that's why we'll try to clear them.
	PUSHF
	POP	AX
	AND	AH,0x0F		;(clear most significant bits)
	PUSH	AX
	POPF
	PUSHF
	POP	AX
	AND	AH,0xF0		;(get them back)
	CMP	AH,0xF0
	JZ	CPUID_2		;if all set, it's a 8086/8088
  ;; on the 80286, on the opposite, they are cleared
	INC	DH
	PUSHF
	POP	AX
	OR	AH,0xF0		;(set most significant bits)
	PUSH	AX
	POPF
	PUSHF
	POP	AX
	AND	AH,0xF0		;(get them back)
	JZ	CPUID_2		;if cleared, it's a 80286
  ;; on the 80486, the EFLAGS registers has got an AC alignment bit
  ;; from late 486s on, the EFLAGS register has an ID bit (authorize CPUID)
  ;; masks are 40000 and 20000 respectively.
	INC	DH
	CLI
	AND	SP,~3		; align SP
	PUSHFD
	POP	EAX
	MOV	EBX,EAX		; save EFLAGS
	XOR	EAX,0x00060000	; complement AC
	PUSH	EAX
	POPFD
	PUSHFD
	POP	EAX
	PUSH	EBX
	POPFD			; restore AC
	MOV	SP,BP		; restore SP
	XOR	EAX,EBX		; look if AC or ID was modified
	STI
	JZ	CPUID_2		; no: it's a 386
	INC	DH
	TEST	EAX,0x20000	; ID modified ?
	JZ	CPUID_2		; no, it's an early 486
  ;; now, we can use the CPUID instruction to determine the CPU type
  	MOV	EAX,1		; should we use "xor eax,eax ; inc ax" ?
	.byte	0x0F		; CPUID
	.byte	0xA2
	AND	AH,7		; CPU type in EAX[11:8]
	MOV	DH,AH		; stored in DH
  ;;;; Now, test for coprocessor:
CPUID_2:
	FNINIT				;reset status word
	FNSTSW	[BP]
	CMP	byte [BP],0		;if non zero, no FPU
	JNZ	CPUID_3
	FNSTCW	[BP]			;try to write control word
	AND	word [BP],0x103F
	CMP	word [BP],0x3F
	JNZ	CPUID_3
  ;;;; The only case when the FPU doesn't answer is a 80386+80287
	MOV	DL,DH			;initialize FPU type
	CMP	DH,3			;no 386 => ok
	JNZ	CPUID_3
  ;;; 387/287: the initialized NDP must manage infinity,
  ;;; but they're the same to the 287	FLD1
	FLDZ
	FDIV	ST,ST
	FLD	ST
	FCHS
	FCOMPP
	FSTSW	[BP]
	MOV	AX,[BP]
	SAHF
	JNZ	CPUID_3			;different => 387
	DEC	DL
CPUID_3:
	MOV	AX,DX
	__RET__
})dnl
dnl
dnl
dnl ------------------- Memory management in protected mode ------------------
dnl see file "mem386.doc" for dox...
dnl
dnl ------ A20 line control -----
dnl
dnl --- Constants to access line A20
define({KB_command_port},0x64)dnl  IOaddr to write to
define({KB_status_port}, 0x64)dnl  IOaddr to read from
define({KB_data_port},	 0x60)dnl  IOaddr to read from
define({IB_free},	 0x02)dnl  status bitmask: is kbd controller ready ?
define({KB_command_A20}, 0xD1)dnl  command bitmask to access A20 line.
define({set_A20_ON},     0xDF)dnl
define({set_A20_OFF},	 0xDD)dnl
dnl
dnl --- Macros to control line A20
dnl
define({Lib_KB_Ready},{
  local({wait_IB},{{
dnl ;; Test if kbd port is available (needed before to send it commands)
dnl ;; - {$1} must be a label where to jump if line not available
dnl ;; - {$2} must be the number of tries before to jump to {$1}
dnl ;; ** destroys AX,CX
   ifelse({$2},,{mov regext(cx){,}100},
		{ifelse({$2},{regext(cx)},,{mov regext(cx),{$2}})})
  wait_IB:
   in al,#KB_status_port
   test al,#IB_free
   loopne wait_IB
   jcxz {$1}
   __RET__
}})})dnl
dnl
define({Lib_Set_A20},{
 ;; (de)activivates line A20,
 ;; - {$1} is ON or OFF, or void (then ah contains A20_ON or A20_OFF)
 ;; - (!) keyboard must be ready (use previous macro for that)
 ;; ** destroys AX
  ifelse({$1},,,{mov ah,{#set_A20_}ON_OFF})
  mov al,#KB_command_A20
  out #KB_command_port,al
  ; Linus does call KB_Ready again !
  mov al,ah
  out #KB_command_port,al
  ; Linus does call KB_Ready again !
  __RET__
})dnl
dnl
define({Test_A20},{
   local({Exit_},{
   ;; * tests if line A20 is activated, by seeing whether addresses are
   ;;  wrapped over 1MB.
   ;; * sets ax iff the line is activated
   pushm(ds,es,f)
   cli			; disable interrupts
   clr(ax)
   mov es,ax		; es=$0000
   dec ax
   mov ds,ax		; ds=$FFFF
   mov ax,[-2]		;; verify [$10FFEE]=[$0FFEE]
   seg es
   cmp ax,[-18]
   stc
   jnz Exit_
   inc [-2]		;; verify [$10FFEE]=[$0FFEE] after modification
   seg es
   cmp ax,[-18]
   mov [-2],ax
   mov ax,-1
   jz Exit_
   inc ax
  Exit_:
   popm(ds,es,f)	; enable interrupts again if needed
   __RET__
})})dnl
dnl
;;; NMI enabling/disabling
define({Lib_Disable_NMI},{
	mov al,#0x80
	out #0x70,al
	in al,#0x71
	__RET__
})dnl
define({Lib_Enable_NMI},{
	mov al,#0x00
	out #0x70,al
	in al,#0x71
	__RET__
})dnl
dnl
dnl
dnl "...to accomplish a warm boot equivalent to Ctrl-Alt-Del, store 1234h
dnl in 0040h:0072h and jump to FFFFh:0000h.    For a cold boot equivalent
dnl to a reset, store 0000h at 0040h:0072h before jumping."
dnl
define({Lib_Reset_Computer},{
	mov al,#0xF0
	out #0x64,al
})dnl
dnl
dnl
dnl --- XMS Memory move ---
dnl
Struc({XMSMP},{
; Struc XMS_Move_Params		;; parameters for XMS func 0Bh
   _long_(LengthToMove)dnl
   _word_(SourceHandle)dnl
   _long_(SourceOffset)dnl
   _word_(DestHandle)dnl
   _long_(DestOffset)dnl
})dnl
dnl
dnl
dnl --- Segment descriptors ---
dnl
DT_PageGrain	=	0x80 ; bit G "granularity"
DT_Exec32	=	0x40 ; bit D "default" set iff code is 32 bit
DT_Available	=	0x10 ; bit AVL
DT_Present	=	0x80 ; segment present
DT_Ring0	=	0x00 ; descriptor priviledge
DT_Ring1	=	0x20
DT_Ring2	=	0x40
DT_Ring3	=	0x60
DT_Segment	=	0x10 ; bit DT "descriptor type", 1: segment, 0: special
; if DT_Segment (bit DT) is set:
DT_Accessible	=	0x1
DT_Data		=	0x0
DT_ExtDown	=	0x4 ; data segment extends downward
DT_Writable	=	0x2 ; segment is writable
DT_Code		=	0x8
DT_Conforming	=	0x4
DT_Readable	=	0x2 ; segment is readable
; if DT_Segment -bit DT) is cleared:
DT_TSS16_A	=	0x1 ; available TSS 16
DT_LDT		=	0x2 ; LDT
DT_TSS16_B	=	0x3 ; busy TSS 16
DT_CallGate16	=	0x4
DT_TaskGate	=	0x5
DT_IntGate16	=	0x6
DT_TrapGate16	=	0x7
DT_TSS32_A	=	0x9 ; available TSS 32
DT_TSS32_B	=	0xB ; busy TSS 32
DT_CallGate32	=	0xC
DT_IntGate32	=	0xE
DT_TrapGate32	=	0xF
dnl
define({DefDescriptor},{
;	base,limit,_P_DPL_DT_Type,_G_D_0_AVL
	.word	($2) & 0xFFFF
	.word	($1) & 0xFFFF
	.byte	(($1)>>16) & 0xFF
	.byte	($3)
	.byte	($4) + ( (($2)>>16)&0xF )
	.byte	($1)>>24
})dnl
define({DefGate},{
;	sel,ofs,compteur,_P_DPL_DT_Type
	.word	($2) & 0xFFFF
	.word	$1
	.byte	$3
	.byte	$4
	.word	($2) >> 16
})dnl
define({Lib_SetDescriptor},{
;	DESCRIPT
   ;;; initialize a descriptor with
   ;;; - {$1} being the base address of the descriptor to initialize
   ;;; - ebx is base address of the segment
   ;;; - ecx is the limit field in byte or page according to granularity
   ;;; - al has got fields: P,DPL,DT,Type
   ;;; - ah has got fields: G,D,AVL
   ;;; * the routine destroys eax,ebx,ecx
   mov [$1],cx
   shr ecx,16
   mov [$1+2],bx
   shr ebx,16
   or cl,ah
   mov ch,bh
   mov bh,al
   mov [$1+4],bx
   mov [$1+6],cx
   __RET__
})dnl
define({Lib_GetDescriptor},{
;	DESCRIPT
   ;;; This macro does the converse of preceding one:
   ;;; - {$1} contains base address of the descriptor
   ;;; * returns in ebx the base address of the segment
   ;;; * returns in ecx the limit field
   ;;; * returns in al fields: P,DPL,DT,Type
   ;;; * returns in ah fields: G,D,AVL
   mov cx,[$1+6]
   mov bx,[$1+4]
   mov al,bh
   mov bh,ch
   mov ah,cl
   and cx,0xF
   shl ebx,16
   mov bx,[$1+2]
   shl ecx,16
   mov cx,[$1]
   __RET__
})dnl
Struc({pushad},{
  irp(reg,{edi,esi,ebp,esp,ebx,edx,ecx,eax},
	{_long_(reg)})
})dnl
Struc({pusha},{
  irp(reg,{di,si,bp,sp,bx,dx,cx,ax},
	{_word_(reg)})
})dnl
Struc({TSS16},{
; SP_CPLx and LDT are not updated by task switching
  irp(reg,
	{BackLinkSelector,
	 SP_CPL0,SS_CPL0,
	 SP_CPL1,SS_CPL1,
	 SP_CPL2,SS_CPL2,
	 IP,FLAGS,
	 AX,CX,DX,BX,
	 SP,BP,SI,DI,
	 ES,CS,SS,DS,
	 LDT},
	{_word_(reg)})
})dnl
Struc({TSS32},{
; ESP_CPLx and LDT are not updated by task switching
  irp(reg,
	{BackLinkSelector,
	 ESP_CPL0,SS_CPL0,
	 ESP_CPL1,SS_CPL1,
	 ESP_CPL2,SS_CPL2,
	 EIP,EFLAGS,
	 EAX,ECX,EDX,EBX,
	 ESP,EBP,ESI,EDI,
	 ES,CS,SS,DS,
	 LDT},
	{_long_(reg)})
    _word_(TrapBit)
    _word_(IO_Map_Base)
})dnl
dnl
dnl
})dnl ------------------- end of as86 macros -------------------------
dnl
dnl
